
stages:
  - lint
  - package-publish

variables:
  HELM_EXPERIMENTAL_OCI: 1  # Включает поддержку OCI для Helm 3.7+
  HELM_DIR: "./"

lint:
  stage: lint
  tags:
    - kuber
  script:
    - helm lint ${HELM_DIR}

.increment_version:
  before_script:
    - chmod +x ./version_i++.sh && source ./version_i++.sh              # sh | bash - текушие ранер shell
    - git config user.name "ranner"
    - git config user.email "ci@ranner.com"
    - git add Chart.yaml
    - git commit -m "version $NEW_VERSION [skip ci]"
    - git remote set-url origin https://oauth2:${GITLAB_ACCESS_TOKEN}@gitlab.com/${CI_PROJECT_PATH}.git
    - git push origin HEAD:$CI_COMMIT_REF_NAME

helm-package:
  extends: .increment_version
  stage: package-publish
 # image:
  #  name: alpine/helm:3.5.3
 #   entrypoint: [""]
  tags:
    - kuber
  variables:
    CHART_REPO: chart_repo_flask
  script:
     # - apk add --no-cache git
    - |
      if helm plugin list | grep -q "cm-push"; then
          echo "Плагин helm-push уже установлен."
      else
          helm plugin install https://github.com/chartmuseum/helm-push
      fi
    - mkdir -p ./packages
    - helm package ./ --destination ./packages    # имя пакета берется из чарта
    - PACKEGE_NAME=$(ls ./packages)
    - |
      helm repo add --username $CI_REGISTRY_USER \
      --password "$CI_REGISTRY_PASSWORD" \
      ${CHART_REPO} "$CI_API_V4_URL/projects/$CI_PROJECT_ID/packages/helm/stable" 
    - helm cm-push ./packages/${PACKEGE_NAME} ${CHART_REPO}
    - helm repo remove ${CHART_REPO}
  only:
    refs:
      - main

 
 